#  Cross compile do python 2.5 09/09/2005
#  Based on "K's cluttered loft - ARM cross-compiling howto"
#  http://www.ailis.de/~k/docs/crosscompiling/python.php


#1 Aplicar o patch em baixo
#   Apply the patch below
if [ ];then
make distclean
./configure 
make python Parser/pgen

cp python hostpython
cp Parser/pgen hostpgen
fi

make distclean
LDFLAGS="-L/opt/ppc-ptin/lib" CPPFLAGS="-I/opt/ppc-ptin/include" PATH=/opt/ppc-ptin/bin:$PATH CXX=powerpc-linux-g++ CC=powerpc-linux-gcc AR=powerpc-linux-ar RANLIB=powerpc-linux-ranlib ./configure --prefix=/usr --host=powerpc-linux

CPPFLAGS="-I/opt/ppc-ptin/include" LDFLAGS="-L/opt/ppc-ptin/lib" PATH=/opt/ppc-ptin/bin:$PATH CXX=powerpc-linux-g++ CC=powerpc-linux-gcc AR=powerpc-linux-ar RANLIB=powerpc-linux-ranlib LD=powerpc-linux-ld make HOSTPYTHON=./hostpython HOSTPGEN=./hostpgen BLDSHARED="powerpc-linux-gcc -shared" 

CPPFLAGS="-I/opt/ppc-ptin/include" LDFLAGS="-L/opt/ppc-ptin/lib" PATH=/opt/ppc-ptin/bin:$PATH CXX=powerpc-linux-g++ CC=powerpc-linux-gcc AR=powerpc-linux-ar RANLIB=powerpc-linux-ranlib LD=powerpc-linux-ld make install prefix=/home/jmatos/work/busybox_brouter8/_install HOSTPYTHON=./hostpython HOSTPGEN=./hostpgen BLDSHARED="powerpc-linux-gcc -shared" CROSS_COMPILE=yes 

exit 0



? Makefile.pre.in.Modified
? hostpgen
? hostpython
? mmap-block.diff
? mmap-reg.diff
? mmap-test.diff
? mmap_1.patch
? mmap_2.patch
? my_diff.diff
? Doc/lib.aux
? Doc/lib.dvi
? Doc/lib.idx
? Doc/lib.ind
? Doc/lib.l2h
? Doc/lib.log
? Doc/lib.pla
? Doc/lib.toc
? Doc/lib2.syn
? Doc/lib3.syn
? Doc/lib4.syn
? Doc/lib5.syn
? Doc/lib6.syn
? Doc/lib7.syn
? Doc/modlib.idx
? Doc/modlib.ind
? Doc/lib/libmmap.log
? Mac/Python
Index: Makefile.pre.in
===================================================================
RCS file: /cvsroot/python/python/dist/src/Makefile.pre.in,v
retrieving revision 1.152
diff -u -r1.152 Makefile.pre.in
--- Makefile.pre.in	24 Apr 2005 22:26:37 -0000	1.152
+++ Makefile.pre.in	14 Sep 2005 15:51:28 -0000
@@ -165,6 +165,7 @@
 
 PYTHON=		python$(EXE)
 BUILDPYTHON=	python$(BUILDEXE)
+HOSTPYTHON=    ./$(BUILDPYTHON)
 
 # === Definitions added by makesetup ===
 
@@ -192,6 +193,8 @@
 # Parser
 PGEN=		Parser/pgen$(EXE)
 
+HOSTPGEN=	$(PGEN)
+
 POBJS=		\
 		Parser/acceler.o \
 		Parser/grammar1.o \
@@ -323,8 +326,8 @@
 # Build the shared modules
 sharedmods: $(BUILDPYTHON)
 	case $$MAKEFLAGS in \
-	*-s*) $(RUNSHARED) CC='$(CC)' LDSHARED='$(BLDSHARED)' OPT='$(OPT)' ./$(BUILDPYTHON) -E $(srcdir)/setup.py -q build;; \
-	*) $(RUNSHARED) CC='$(CC)' LDSHARED='$(BLDSHARED)' OPT='$(OPT)' ./$(BUILDPYTHON) -E $(srcdir)/setup.py build;; \
+	*-s*) $(RUNSHARED) CC='$(CC)' LDSHARED='$(BLDSHARED)' OPT='$(OPT)' $(HOSTPYTHON) -E $(srcdir)/setup.py -q build;; \
+	*) $(RUNSHARED) CC='$(CC)' LDSHARED='$(BLDSHARED)' OPT='$(OPT)' $(HOSTPYTHON) -E $(srcdir)/setup.py build;; \
 	esac
 
 # buildno should really depend on something like LIBRARY_SRC
@@ -445,7 +448,7 @@
 
 
 $(GRAMMAR_H) $(GRAMMAR_C): $(PGEN) $(GRAMMAR_INPUT)
-		-$(PGEN) $(GRAMMAR_INPUT) $(GRAMMAR_H) $(GRAMMAR_C)
+		-$(HOSTPGEN) $(GRAMMAR_INPUT) $(GRAMMAR_H) $(GRAMMAR_C)
 
 $(PGEN):	$(PGENOBJS)
 		$(CC) $(OPT) $(LDFLAGS) $(PGENOBJS) $(LIBS) -o $(PGEN)
@@ -722,19 +725,19 @@
 	done
 	$(INSTALL_DATA) $(srcdir)/LICENSE $(DESTDIR)$(LIBDEST)/LICENSE.txt
 	PYTHONPATH=$(DESTDIR)$(LIBDEST)  $(RUNSHARED) \
-		./$(BUILDPYTHON) -Wi -tt $(DESTDIR)$(LIBDEST)/compileall.py \
+		$(HOSTPYTHON) -Wi -tt $(DESTDIR)$(LIBDEST)/compileall.py \
 		-d $(LIBDEST) -f \
 		-x 'badsyntax|site-packages' $(DESTDIR)$(LIBDEST)
 	PYTHONPATH=$(DESTDIR)$(LIBDEST) $(RUNSHARED) \
-		./$(BUILDPYTHON) -Wi -tt -O $(DESTDIR)$(LIBDEST)/compileall.py \
+		$(HOSTPYTHON) -Wi -tt -O $(DESTDIR)$(LIBDEST)/compileall.py \
 		-d $(LIBDEST) -f \
 		-x 'badsyntax|site-packages' $(DESTDIR)$(LIBDEST)
 	-PYTHONPATH=$(DESTDIR)$(LIBDEST)  $(RUNSHARED) \
-		./$(BUILDPYTHON) -Wi -t $(DESTDIR)$(LIBDEST)/compileall.py \
+		$(HOSTPYTHON) -Wi -t $(DESTDIR)$(LIBDEST)/compileall.py \
 		-d $(LIBDEST)/site-packages -f \
 		-x badsyntax $(DESTDIR)$(LIBDEST)/site-packages
 	-PYTHONPATH=$(DESTDIR)$(LIBDEST) $(RUNSHARED) \
-		./$(BUILDPYTHON) -Wi -t -O $(DESTDIR)$(LIBDEST)/compileall.py \
+		$(HOSTPYTHON) -Wi -t -O $(DESTDIR)$(LIBDEST)/compileall.py \
 		-d $(LIBDEST)/site-packages -f \
 		-x badsyntax $(DESTDIR)$(LIBDEST)/site-packages
 
@@ -829,7 +832,7 @@
 # Install the dynamically loadable modules
 # This goes into $(exec_prefix)
 sharedinstall:
-	$(RUNSHARED) ./$(BUILDPYTHON) -E $(srcdir)/setup.py install \
+	$(RUNSHARED) $(HOSTPYTHON) -E $(srcdir)/setup.py install \
 	   	--prefix=$(prefix) \
 		--install-scripts=$(BINDIR) \
 		--install-platlib=$(DESTSHARED) \
Index: setup.py
===================================================================
RCS file: /cvsroot/python/python/dist/src/setup.py,v
retrieving revision 1.221
diff -u -r1.221 setup.py
--- setup.py	23 Aug 2005 21:19:40 -0000	1.221
+++ setup.py	14 Sep 2005 15:51:35 -0000
@@ -204,32 +204,37 @@
         try:
             imp.load_dynamic(ext.name, ext_filename)
         except ImportError, why:
-            self.announce('*** WARNING: renaming "%s" since importing it'
-                          ' failed: %s' % (ext.name, why), level=3)
-            assert not self.inplace
-            basename, tail = os.path.splitext(ext_filename)
-            newname = basename + "_failed" + tail
-            if os.path.exists(newname):
-                os.remove(newname)
-            os.rename(ext_filename, newname)
-
-            # XXX -- This relies on a Vile HACK in
-            # distutils.command.build_ext.build_extension().  The
-            # _built_objects attribute is stored there strictly for
-            # use here.
-            # If there is a failure, _built_objects may not be there,
-            # so catch the AttributeError and move on.
-            try:
-                for filename in self._built_objects:
-                    os.remove(filename)
-            except AttributeError:
-                self.announce('unable to remove files (ignored)')
+	    if os.environ.get('CROSS_COMPILE') != "yes":
+                self.announce('*** WARNING: renaming "%s" since importing it'
+                              ' failed: %s' % (ext.name, why), level=3)
+                assert not self.inplace
+                basename, tail = os.path.splitext(ext_filename)
+                newname = basename + "_failed" + tail
+                if os.path.exists(newname):
+                    os.remove(newname)
+                os.rename(ext_filename, newname)
+
+                # XXX -- This relies on a Vile HACK in
+                # distutils.command.build_ext.build_extension().  The
+                # _built_objects attribute is stored there strictly for
+                # use here.
+                # If there is a failure, _built_objects may not be there,
+                # so catch the AttributeError and move on.
+                try:
+                    for filename in self._built_objects:
+                        os.remove(filename)
+                except AttributeError:
+                    self.announce('unable to remove files (ignored)')
+            else:
+	       	self.announce('WARNING: "%s" failed importing, but we leave it because we are cross-compiling' %
+		               ext.name)
         except:
             exc_type, why, tb = sys.exc_info()
             self.announce('*** WARNING: importing extension "%s" '
                           'failed with %s: %s' % (ext.name, exc_type, why),
                           level=3)
 
+
     def get_platform(self):
         # Get value of sys.platform
         for platform in ['cygwin', 'beos', 'darwin', 'atheos', 'osf1']:
Index: Lib/test/test_mmap.py
===================================================================
RCS file: /cvsroot/python/python/dist/src/Lib/test/test_mmap.py,v
retrieving revision 1.34
diff -u -r1.34 test_mmap.py
--- Lib/test/test_mmap.py	26 Aug 2005 15:20:48 -0000	1.34
+++ Lib/test/test_mmap.py	14 Sep 2005 15:51:48 -0000
@@ -4,6 +4,47 @@
 
 PAGESIZE = mmap.PAGESIZE
 
+def make_mmap_file(f):
+    # Write 2 pages worth of data to the file
+    f.write('\0'* PAGESIZE)
+    f.write('foo')
+    f.write('\0'* (PAGESIZE-3) )
+    f.flush()
+    return mmap.mmap(f.fileno(), 2 * PAGESIZE)
+
+def test_offset():
+    f = open(TESTFN, 'w+')
+
+    try:    # unlink TESTFN no matter what
+        m = make_mmap_file(f)
+        m.close()
+        f.close()
+
+        mapsize = PAGESIZE * 2
+        # Try invalid offset
+        f = open(TESTFN, "r+b")
+        for offset in [-2, -1, None]:
+            try:
+                m = mmap.mmap(f.fileno(), mapsize, offset=offset)
+            except (ValueError, TypeError):
+                pass
+            else:
+                verify(0, "Invalid offset should raise ValueError.")
+        f.close()
+
+        # Try valid offset, hopefully 8192 works on all OSes
+        f = open(TESTFN, "r+b")
+        m = mmap.mmap(f.fileno(), mapsize - PAGESIZE, offset=PAGESIZE)
+        verify(m[0:3] == 'foo', "Invalid data found using offset.")
+        f.close()
+
+    finally:
+        f.close()
+        try:
+            os.unlink(TESTFN)
+        except OSError:
+            pass
+
 def test_both():
     "Test mmap module on Unix systems and Windows"
 
@@ -13,12 +54,7 @@
     f = open(TESTFN, 'w+')
 
     try:    # unlink TESTFN no matter what
-        # Write 2 pages worth of data to the file
-        f.write('\0'* PAGESIZE)
-        f.write('foo')
-        f.write('\0'* (PAGESIZE-3) )
-        f.flush()
-        m = mmap.mmap(f.fileno(), 2 * PAGESIZE)
+        m = make_mmap_file(f)
         f.close()
 
         # Simple sanity checks
@@ -275,6 +311,17 @@
             else:
                 verify(0, "Incompatible parameters should raise ValueError.")
             f.close()
+
+            # Try invalid offset
+            f = open(TESTFN, "r+b")
+            for offset in [-2, -1, None]:
+                try:
+                    m = mmap.mmap(f.fileno(), mapsize, offset=offset)
+                except (ValueError, TypeError):
+                    pass
+                else:
+                    verify(0, "Invalid offset should raise ValueError.")
+            f.close()
     finally:
         try:
             os.unlink(TESTFN)
Index: Modules/mmapmodule.c
===================================================================
RCS file: /cvsroot/python/python/dist/src/Modules/mmapmodule.c,v
retrieving revision 2.50
diff -u -r2.50 mmapmodule.c
--- Modules/mmapmodule.c	24 Aug 2005 07:17:39 -0000	2.50
+++ Modules/mmapmodule.c	14 Sep 2005 15:51:59 -0000
@@ -3,6 +3,9 @@
  /  Hacked for Unix by AMK
  /  $Id: build_python.sh,v 1.4 2005/09/14 15:40:41 jmatos Exp $
 
+ / Modified to support mmap with offset - to map a 'window' fo a file
+ /   Author:  Yotam Medini  yotamm@mellanox.co.il
+ /
  / mmapmodule.cpp -- map a view of a file into memory
  /
  / todo: need permission flags, perhaps a 'chsize' analog
@@ -66,9 +69,10 @@
 
 typedef struct {
 	PyObject_HEAD
-	char *	data;
+	volatile char *	data;
 	size_t	size;
-	size_t	pos;
+	off_t	pos;    /* relative to offset */
+	off_t	offset; /* always 0 for MS_WINDOWS */
 
 #ifdef MS_WINDOWS
 	HANDLE	map_handle;
@@ -255,11 +259,11 @@
 				/* nothing */;
 			if (i == len) {
 				return Py_BuildValue (
-					"l",
-					(long) (p - self->data));
+					"I",
+                                       (unsigned long)(self->offset + (p - self->data)));
 			}
 		}
-		return Py_BuildValue ("l", (long) -1);
+		return Py_BuildValue ("I", (unsigned long) -1);
 	}
 }
 
@@ -453,16 +457,16 @@
 	CHECK_VALID(NULL);
         if (!PyArg_ParseTuple(args, ":tell"))
 		return NULL;
-	return (Py_BuildValue ("l", (long) self->pos) );
+	return (Py_BuildValue ("I", (unsigned int) (self->offset + self->pos)) );
 }
 
 static PyObject *
 mmap_flush_method(mmap_object *self, PyObject *args)
 {
-	size_t offset	= 0;
-	size_t size = self->size;
+	off_t offset	= 0;
+	off_t size = self->size;
 	CHECK_VALID(NULL);
-	if (!PyArg_ParseTuple (args, "|ll:flush", &offset, &size)) {
+	if (!PyArg_ParseTuple (args, "|II:flush", &offset, &size)) {
 		return NULL;
 	} else if ((offset + size) > self->size) {
 		PyErr_SetString (PyExc_ValueError,
@@ -490,28 +494,29 @@
 static PyObject *
 mmap_seek_method(mmap_object *self, PyObject *args)
 {
-	int dist;
+	unsigned int dist;
 	int how=0;
 	CHECK_VALID(NULL);
-	if (!PyArg_ParseTuple (args, "i|i:seek", &dist, &how)) {
+	if (!PyArg_ParseTuple (args, "I|i:seek", &dist, &how)) {
 		return(NULL);
 	} else {
 		size_t where;
 		switch (how) {
 		case 0: /* relative to start */
-			if (dist < 0)
+			dist -= self->offset;
+			if (dist >= self->size)
 				goto onoutofrange;
 			where = dist;
 			break;
 		case 1: /* relative to current position */
-			if ((int)self->pos + dist < 0)
+			if ((int)self->pos + (int)dist < 0)
 				goto onoutofrange;
-			where = self->pos + dist;
+			where = self->pos + (int)dist;
 			break;
 		case 2: /* relative to end */
-			if ((int)self->size + dist < 0)
+			if ((int)self->size + (int)dist < 0)
 				goto onoutofrange;
-			where = self->size + dist;
+			where = self->size + (int)dist;
 			break;
 		default:
 			PyErr_SetString (PyExc_ValueError,
@@ -535,10 +540,12 @@
 {
 	unsigned long dest, src, count;
 	CHECK_VALID(NULL);
-	if (!PyArg_ParseTuple (args, "iii:move", &dest, &src, &count) ||
+	if (!PyArg_ParseTuple (args, "III:move", &dest, &src, &count) ||
 	    !is_writeable(self)) {
 		return NULL;
 	} else {
+		dest -= self->offset;
+		src  -= self->offset;
 		/* bounds check the values */
 		if (/* end of source after end of data?? */
 			((src+count) > self->size)
@@ -857,19 +864,26 @@
 #endif
 	mmap_object *m_obj;
 	PyObject *map_size_obj = NULL;
+	PyObject *map_offset_obj = NULL;
 	int map_size;
 	int fd, flags = MAP_SHARED, prot = PROT_WRITE | PROT_READ;
 	access_mode access = ACCESS_DEFAULT;
+	off_t offset = 0;
 	char *keywords[] = {"fileno", "length", 
 			    "flags", "prot", 
-			    "access", NULL};
+			    "access", "offset", NULL};
 
-	if (!PyArg_ParseTupleAndKeywords(args, kwdict, "iO|iii", keywords, 
-					 &fd, &map_size_obj, &flags, &prot, &access))
+	if (!PyArg_ParseTupleAndKeywords(args, kwdict, "iO|iiiO", keywords, 
+					 &fd, &map_size_obj, &flags, &prot, 
+                                         &access, &map_offset_obj))
 		return NULL;
 	map_size = _GetMapSize(map_size_obj);
 	if (map_size < 0)
 		return NULL;
+        if (map_offset_obj)
+        {
+		offset = (off_t)PyInt_AsUnsignedLongMask(map_offset_obj);
+        }
 
 	if ((access != ACCESS_DEFAULT) && 
 	    ((flags != MAP_SHARED) || ( prot != (PROT_WRITE | PROT_READ))))
@@ -904,7 +918,8 @@
 	if (fstat(fd, &st) == 0 && S_ISREG(st.st_mode)) {
 		if (map_size == 0) {
 			map_size = (int)st.st_size;
-		} else if ((size_t)map_size > st.st_size) {
+		} 
+		if (offset + (size_t)map_size > st.st_size) {
 			PyErr_SetString(PyExc_ValueError, 
 					"mmap length is greater than file size");
 			return NULL;
@@ -915,6 +930,7 @@
 	if (m_obj == NULL) {return NULL;}
 	m_obj->size = (size_t) map_size;
 	m_obj->pos = (size_t) 0;
+	m_obj->offset = offset;
 	m_obj->fd = dup(fd);
 	if (m_obj->fd == -1) {
 		Py_DECREF(m_obj);
@@ -923,7 +939,7 @@
 	}
 	m_obj->data = mmap(NULL, map_size, 
 			   prot, flags,
-			   fd, 0);
+			   fd, offset);
 	if (m_obj->data == (char *)-1) {
 	        m_obj->data = NULL;
 		Py_DECREF(m_obj);
@@ -1000,6 +1016,7 @@
 	m_obj->file_handle = INVALID_HANDLE_VALUE;
 	m_obj->map_handle = INVALID_HANDLE_VALUE;
 	m_obj->tagname = NULL;
+	m_obj->offset = 0;
 
 	if (fh) {
 		/* It is necessary to duplicate the handle, so the

 	  	 
